<div class="tab-pane active code110" id="gcodes">
<ng-form name="formGCodes">
<uib-tabset class="margin-top">
<uib-tab heading="<?php _('Quick Commands') ?>">
<div class="row margin-top">
<div class="col-sm-12">
<button ng-click="addQuickCommand()" class="btn btn-primary">
<i class="fa fa-plus rs-bigtab"></i> <?php _('Add New Command') ?></button>
</div>
</div>
<div class="row margin-top" ng-if="editor.quickCommands">
<div class="col-lg-3 col-md-4 col-sm-12 col-xs-12">
<ul class="list-group" role="tablist" dnd-list="editor.quickCommands">
<li ng-click="selectQuickCommand(s)" style="cursor:move" class="list-group-item" ng-class="{active:s===selectedCommand}" ng-repeat="s in editor.quickCommands" dnd-draggable="s" dnd-moved="editor.quickCommands.splice($index, 1)" dnd-effect-allowed="move" dnd-dragend="onDragEndQuickCommand(event)">
<div>{{idxName($index,s.name,"<?php _('-- ERROR - No Name --') ?>")}}</div>
</li>
</ul>
</div>
<div class="col-lg-9 col-md-8 col-sm-12 col-xs-12" ng-if="selectedCommand">
<div class="form-group">
<label class="control-label"><?php _('Command Name') ?></label>
<div class="input-group">
<input type="text" class="form-control" ng-model="selectedCommand.name" placeholder="<?php _('Your Command Name') ?>" required>
<span class="input-group-btn">
<div class="btn btn-danger" style="height:34px" title="<?php _('Delete Command') ?>" ng-click="delQuickCommand(selectedCommand)">
<i class="fa fa-trash-o rs-bigtab"></i>
</div>
</span>
</div>
</div>
<div class="form-group">
<label class="control-label"><?php _('Icon (optional)') ?></label>
<rs-icon-editor ng-model="selectedCommand.icon" default-icon=""></rs-icon-editor>
</div>
<div class="form-group margin-top">
<label class="control-label"><?php _('G-Code to Execute') ?></label>
<div class="code300">
<ui-codemirror ng-if="!$root.mobile" ui-codemirror-opts="editorOptions" ng-model="selectedCommand.command" style="width:100%;height:100px"></ui-codemirror>
<textarea ng-if="$root.mobile" ng-model="selectedCommand.command" style="width:100%;height:300px"></textarea>
</div>
</div>
</div>
</div>
<div class="invisible" style="height: 0">
<input ng-repeat="s in editor.quickCommands track by $index" type="text" class="form-control" ng-model="s.name" placeholder="<?php _('Your Command Name') ?>" required>
</div>
<p class="alert alert-info margin-top"><?php _('These commands appear in the printer console as pull-down menu. Enter here often used code sequences.') ?></p>
</uib-tab>
<uib-tab heading="<?php _('Button Commands') ?>">
<div class="row margin-top" ng-if="editor.buttonCommands">
<div class="col-lg-3 col-md-4 col-sm-12 col-xs-12">
<ul class="list-group" role="tablist">
<li ng-click="updateButtonDefault(s)" class="list-group-item" ng-class="{active:s===btn.activeButton}" ng-repeat="s in editor.buttonCommands">
<div>{{idxName($index,s.name,"")}}</div>
</li>
</ul>
</div>
<div class="col-lg-9 col-md-8 col-sm-12 col-xs-12" ng-if="btn.activeButton">
<h3 style="margin-top:0">{{btn.activeButton.name}}</h3>
<label><?php _('Default G-Code') ?></label>
<pre><code ng-bind="btn.activeButtonDefault"></code></pre>
<label><?php _('Use this instead') ?></label>
<ui-codemirror ng-if="!$root.mobile" ui-codemirror-opts="editorOptions" ng-model="btn.activeButton.command" style="width:100%;height:150px"></ui-codemirror>
<textarea ng-if="$root.mobile" class="cmevent" ng-model="btn.activeButton.command" style="width:100%;height:100px"></textarea>
</div>
</div>
<div class="alert alert-info margin-top">
<p><?php _('Buttons in the UI execute the default command for your firmware, unless you define your own code to be executed here.') ?></p>
</div>
</uib-tab>
<uib-tab heading="<?php _('Event Dependent') ?>">
<div class="row margin-top">
<div class="col-lg-3 col-md-4 col-sm-12 col-xs-12">
<ul class="list-group" role="tablist">
<li ng-click="$parent.activeScript=s" class="list-group-item" ng-class="{active:s===activeScript}" ng-repeat="s in config.scriptNames">
<div>{{idxName($index,s.title,"")}}</div>
</li>
</ul>
</div>
<div class="col-lg-9 col-md-8 col-sm-12 col-xs-12" ng-if="activeScript">
<h3 style="margin-top:0">{{activeScript.title}}</h3>
<label><?php _('G-Code') ?></label>
<div class="code300">
<ui-codemirror ng-if="!$root.mobile" ui-codemirror-opts="editorOptions" ng-model="config.scripts[activeScript.name]" style="width:100%;height:300px"></ui-codemirror>
<textarea ng-if="$root.mobile" class="cmevent" ng-model="config.scripts[activeScript.name]" style="width:100%;height:300px"></textarea>
</div>
</div>
</div>
<p class="alert alert-info margin-top"><?php _('These commands get send on certain events, like if a job was paused.') ?></p>
</uib-tab>
<uib-tab heading="<?php _('Response to Event') ?>">
<p class="margin-top"><?php _('These rules are used to send an event to watchers if a line returned by the printer matches the regular expression.') ?></p>
<div class="row">
<div class="col-sm-12">
<button ng-click="addResponseEvent()" class="btn btn-primary">
<i class="fa fa-plus rs-bigtab"></i> <?php _('Add New Event Generator') ?></button>
</div>
</div>
<div class="row margin-top">
<div class="col-lg-3 col-md-4 col-sm-12 col-xs-12">
<ul class="list-group" role="tablist" dnd-list="editor.responseEvents">
<li ng-click="$parent.activeResponseEvent=s" class="list-group-item" style="cursor:move" ng-class="{active:s===activeResponseEvent}" ng-repeat="s in editor.responseEvents" dnd-draggable="s" dnd-moved="editor.responseEvents.splice($index, 1)" dnd-effect-allowed="move">
<div>{{idxName($index,s.event,"-- <?php _('No Event Name') ?> --")}}</div>
</li>
</ul>
</div>
<div class="col-lg-9 col-md-8 col-sm-12 col-xs-12" ng-if="activeResponseEvent">
<div ng-if="activeResponseEvent !== false" class="code300">
<h3 style="margin-top:0">{{activeResponseEvent.event}}</h3>
<div>
<label class="control-label"><?php _('Event') ?></label>
<div>
<div class="input-group">
<input type="text" class="form-control" ng-model="activeResponseEvent.event" placeholder="<?php _('Your Event Name') ?>">
<span class="input-group-btn">
<div class="btn btn-danger" style="height:34px" title="<?php _('Delete Event') ?>" ng-click="delResponseEvent(activeResponseEvent)">
<i class="fa fa-trash-o rs-bigtab"></i>
</div>
</span>
</div>
</div>
<label class="control-label margin-top"><?php _('Regular Expression') ?></label>
<div>
<input type="text" class="form-control" ng-model="activeResponseEvent.expression" placeholder="<?php _('Your Regular Expression') ?>">
</div>
<div class="form-group margin-top">
<label class="control-label"><?php _('G-Code to Execute') ?></label>
<div>
<ui-codemirror ng-if="!$root.mobile" ui-codemirror-opts="editorOptions" ng-model="activeResponseEvent.script" style="width:100%;"></ui-codemirror>
<textarea ng-if="$root.mobile" ng-model="activeResponseEvent.script" style="width:100%;height:300px"></textarea>
</div>
</div>
</div>
</div>
</div>
</div>
<div class="alert alert-info margin-top">
<p><?php _('Use @0 to insert complete firmware response and @1 to insert the first matching group into the script.') ?></p>
</div>
</uib-tab>
<uib-tab heading="<?php _('Replacements') ?>">
<div class="row margin-top">
<div class="col-sm-12">
<button ng-click="addReplacement()" class="btn btn-primary">
<i class="fa fa-plus rs-bigtab"></i> <?php _('Add New Replacement') ?></button>
</div>
</div>
<div class="row margin-top">
<div class="col-lg-3 col-md-4 col-sm-12 col-xs-12">
<ul class="list-group" role="tablist" dnd-list="editor.gcodeReplacements">
<li ng-click="$parent.activeReplacement=s" class="list-group-item" style="cursor:move" ng-class="{active:s===activeReplacement}" ng-repeat="s in editor.gcodeReplacements" dnd-draggable="s" dnd-moved="editor.gcodeReplacements.splice($index, 1)" dnd-effect-allowed="move">
<div>{{idxName($index,s.comment,"-- <?php _('No Comment') ?> --")}}</div>
</li>
</ul>
</div>
<div class="col-lg-9 col-md-8 col-sm-12 col-xs-12" ng-if="activeResponseEvent">
<div ng-if="activeReplacement !== false" class="code300">
<h3 style="margin-top:0">{{activeReplacement.comment}}</h3>
<div class="form-group">
<label class="control-label"><?php _('Comment') ?></label>
<div class="input-group">
<input type="text" class="form-control" ng-model="activeReplacement.comment" placeholder="<?php _('Your Comment') ?>">
<span class="input-group-btn">
<div class="btn btn-danger" style="height:34px" title="<?php _('Delete') ?>" ng-click="delReplacement(activeReplacement)">
<i class="fa fa-trash-o rs-bigtab"></i>
</div>
</span>
</div>
</div>
<div class="form-group">
<label class="control-label"><?php _('Regular Expression') ?></label>
<div>
<input type="text" class="form-control" ng-model="activeReplacement.expression" placeholder="<?php _('Your Regular Expression') ?>">
</div>
</div>
<div class="form-group margin-top">
<label class="control-label"><?php _('G-Code to Execute') ?></label>
<div>
<ui-codemirror ng-if="!$root.mobile" ui-codemirror-opts="editorOptions" ng-model="activeReplacement.script" style="width:100%;height:100px"></ui-codemirror>
<textarea ng-if="$root.mobile" ng-model="activeReplacement.script" style="width:100%;height:300px"></textarea>
</div>
</div>
</div>
</div>
</div>
<div class="alert alert-info margin-top">
<p><?php _('These rules are used to replace a command with some other commands. Replacement is not rescanned. The first hit will be used.') ?></p>
<p><?php _('Use @0 to insert complete request and @1 to insert the first matching group into the script.') ?></p>
</div>
</uib-tab>
</uib-tabset>
<div class="margin-bottom clearfix">
<button ng-hide="config.hasErrors()" class="btn btn-success pull-right" ng-click="config.save()"><i class="fa fa-save rs-bigtab"></i> <?php _('Save Configuration') ?>
</button>
<button ng-show="config.hasErrors()" class="btn btn-danger pull-right disabled" ng-click="config.save()"><i class="fa fa-save rs-bigtab"></i> <?php _('Fix errors to update') ?>
</button>
</div>
<br>
</ng-form>
</div>
